{{!-- {{log "chatCard-action-block-entryV2.hbs this" this}} --}}


{{!-- {{log "chatCard-action-block-entryV2.hbs actionGroup" actionGroup}} --}}

{{!-- #psionic --}}
{{#ifnoteqMulti actionGroup.source.type 'spell' 'power'}}
    <div class="flexrow action-card-image-title">
        <div class="a25-image" style="">
            <img class="a25-token"
                src="{{#if actionGroup.img}}{{actionGroup.img}}{{else}}{{actionGroup.source.img}}{{/if}}"
                data-tooltip="{{#if actionGroup.name}}{{actionGroup.name}}{{else}}{{actionGroup.source.name}}{{/if}}"
                width="50" height="50" />
        </div>
        <div class="action-title">
            {{#if actionGroup.name}}
                {{actionGroup.name}}
            {{else}}
                {{#if actionGroup.source}}
                    {{#if actionGroup.source.isOwned}}
                        {{actionGroup.source.name}}: {{actionGroup.name}}
                    {{/if}}
                {{/if}}
            {{/if}}
        </div>
    </div>
    {{#if actionGroup.description}}
        <div class="chatCard-description chatCard-action-block-entryV2-hbs">
            <div style="display: none" class="chatCard-description-full">
                {{{ actionGroup.description }}}
            </div>
            {{#if actionGroup.description}}
                <div class="chatCard-expand-view"><i class="fas fa-expand-alt"></i></div>
            {{/if}}
        </div>
    {{/if}}
{{/ifnoteqMulti}}

<div class="flexcol">

    {{!-- bulk action widget -- extendable prototype --}}
    <div class="bulk-actions-widget" data-owner-id="{{@root.owner}}" data-source-actor-id="{{@root.sourceActor.id}}"
        data-source-token-id="{{@root.sourceToken.id}}" data-item-id="{{@root.item.id}}">
        {{#if actionGroup.hasBulkAttack}}
            <button class="chatCard-button bulk" class="chatCard-button" data-action="attack-all">
                <img src="icons/weapons/swords/swords-short.webp"
                    data-tooltip="Bulk Attack - Hold CTRL to bypass modifier dialog" />
            </button>
        {{/if}}
        {{#if actionGroup.hasBulkDamage}}
            <button class="chatCard-button bulk" class="chatCard-button" data-action="damage-all">
                <img src="icons/skills/wounds/blood-spurt-spray-red.webp"
                    data-tooltip="Bulk Damage - Hold CTRL to bypass modifier dialog" />
            </button>
        {{/if}}

    </div>

    {{#each (mapToArray actionGroup.actions) as |action|}}


        {{!-- {{log "actionV2 action = " action}} --}}
        <div class="actionChat-list" data-owner-id="{{@root.owner}}" data-source-actor-id="{{@root.sourceActor.id}}"
            data-source-token-id="{{@root.sourceToken.id}}" data-item-id="{{@root.item.id}}"
            data-item-uuid="{{action.source.uuid}}" data-sourceitem-uuid="{{action.source.uuid}}"
            data-action-group-id="{{action.parentGroup.id}}" data-action-id="{{action.id}}">

            {{!-- build the buttons for the various actions ... --}}
            {{#if (eq action.type 'use')}}
                <button class="chatCard-button" class="chatCard-button" data-action="use-roll">
                    <div class="flexrow">
                        <div class="action-icon"><img src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text">{{localize "ARS.chat.use"}}</div>
                    </div>
                </button>
            {{/if}}

            {{#if (eq action.type 'castshape')}}
                <button class="chatCard-button" class="chatCard-button" data-action="cast-shape-template">
                    <div class="flexrow">
                        <div class="action-icon"><img src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc" data-tooltip="{{localize "ARS.chat.castshapeToolTip"}}">
                            {{localize "ARS.chat.castshape"}}{{#if action.misc}} ( {{action.misc}} ){{/if}}
                        </div>
                    </div>
                </button>
            {{/if}}


            {{#if (eq action.type 'cast')}}
                <button class="chatCard-button" class="chatCard-button" data-action="cast-roll">
                    <div class="flexrow">
                        <div class="action-icon"><img src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">{{localize "ARS.chat.cast"}}
                            {{#if (eq action.saveCheck.type 'none')}}{{else}} ( Versus
                                {{localize (concat "ARS.saveTypes." action.saveCheck.type)}}
                                {{#if action.saveCheck.formula}}{{action.saveCheck.formula}}{{/if}}){{/if}}
                        </div>
                    </div>
                </button>
            {{/if}}

            {{#includes action.type 'melee||ranged||thrown'}}
                <button class="chatCard-button" data-action="action-attack-roll">
                    <div class="flexrow">
                        <div class="action-icon">
                            <img src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">
                            {{localize "ARS.chat.attack"}}{{#if action.name}} ({{action.name}}){{/if}}
                        </div>
                    </div>
                </button>
            {{/includes}}

            {{#if (eq action.type 'damage')}}
                <button class="chatCard-button" data-action="action-damage-roll" data-tooltip="
                                    {{#if action.formulaEvaluated}}
                                        {{action.formulaEvaluated}}
                                    {{else}}
                                        {{action.formula}}
                                    {{/if}}
                                    {{#if (eq action.damagetype 'none')}}
                                    {{!-- do nothing --}}
                                    {{else}}/{{action.damagetype}}
                                    {{/if}}">
                    <div style="min-width:0;flex-shrink:0;" class="flexrow">
                        <div class="short-field action-icon">
                            <img class="" src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">
                            {{localize "ARS.chat.damage"}} ({{#if action.name}}
                                {{action.name}}
                            {{else}}
                                {{#if action.formulaEvaluated}}
                                    {{ action.formulaEvaluated }}
                                {{else}}
                                    {{action.formula}}
                                {{/if}}
                                {{#if (eq action.damagetype 'none')}}
                                {{else}}/{{ action.damagetype }}
                                {{/if}}
                            {{/if}})
                        </div>
                    </div>
                </button>

            {{/if}}

            {{#if (eq action.type 'heal')}}
                <button class="chatCard-button" data-action="action-heal-roll">
                    <div class="flexrow">
                        <div class="action-icon">
                            <img class="" src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc"
                            style="white-space: nowrap;overflow: hidden;text-overflow: ellipsis;">
                            {{localize "ARS.chat.heal"}} ({{#if action.formulaEvaluated}}
                                {{ action.formulaEvaluated }}
                            {{else}}{{action.formula}}{{/if}})
                        </div>
                    </div>

                </button>
            {{/if}}

            {{#if (eq action.type 'effect')}}
                {{!-- {{log "action.effect EFFECT" action.effect}} --}}
                <button class="chatCard-button text-trunc" data-action="action-effect-roll"
                    data-tooltip="{{action.effect.toolTip}}">
                    <div class="flexrow">
                        <div class="short-field action-icon">
                            <img class="" src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">{{localize "ARS.chat.effect"}}
                            ({{#if action.misc}}{{{action.misc}}}{{else}}{{{action.effect.changes.0.key}}}{{/if}})
                        </div>
                    </div>


                </button>
            {{/if}}
            {{#if (eq action.type 'item-effect')}}
                <button class="chatCard-button text-trunc" data-action="action-item-effect-roll"
                    data-tooltip="{{action.effect.toolTip}}">
                    <div class="flexrow">
                        <div class="short-field action-icon">
                            <img class="" src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">{{@root.item.name}}
                            {{#if action.misc}}({{{action.misc}}}){{else}}{{#if action.effect.changes.0.key}}({{{action.effect.changes.0.key}}}){{/if}}{{/if}}
                        </div>
                    </div>
                </button>
            {{/if}}

            {{!-- macros and scripts --}}
            {{#if (eq action.type 'macro')}}
                <button class="chatCard-button text-trunc" data-action="action-macro-exec">
                    <div class="flexrow">
                        <div class="short-field action-icon">
                            <img class="" src="{{action.img}}" data-tooltip="{{action.name}}" />
                        </div>
                        <div class="center-text text-trunc">{{localize "ARS.actions.type.macro"}}
                            {{#if action.name}}( {{{action.name}}} ){{/if}}
                        </div>
                    </div>
                </button>
            {{/if}}

            {{#includes action.type 'cast||melee||ranged||thrown'}}
                {{#if (eq action.abilityCheck.type 'none')}}
                    {{!-- Do nothing --}}
                {{else}}
                    <button class="chatCard-button" data-action="ability-roll">
                        <div class="flexrow">
                            <div class="action-icon">
                                <img src="{{action.img}}" data-tooltip="{{action.name}}" />
                            </div>
                            <div class="center-text text-trunc">{{localize "ARS.chat.check"}} versus
                                {{localize (concat "ARS.abilityTypes." action.abilityCheck.type)}}
                            </div>
                        </div>
                    </button>
                {{/if}}
            {{/includes}}
        </div>

        {{#includes action.type 'cast||melee||ranged||thrown'}}
            {{#if (eq action.saveCheck.type 'none')}}
                {{!-- Do nothing --}}
            {{else}}
                <div class="chatCard-action-block-entry-hbs-save" data-owner-id="{{@root.owner}}"
                    data-source-actor-id="{{@root.sourceActor.id}}" data-source-token-id="{{@root.sourceToken.id}}"
                    data-item-id="{{@root.item.id}}" data-item-uuid="{{action.source.uuid}}"
                    data-sourceitem-uuid="{{action.source.uuid}}" data-action-id="{{action.id}}"
                    data-action-group-id="{{action.parentGroup.id}}">
                    <button class="chatCard-button" data-action="save-roll">
                        <div class="flexrow">
                            <div class="action-icon"><img src="{{action.img}}" data-tooltip="{{action.name}}" />
                            </div>
                            <div class="center-text text-trunc">{{localize "ARS.chat.save"}} vs
                                {{localize (concat "ARS.saveTypes." action.saveCheck.type)}}
                                {{#if action.saveCheck.formula}}{{action.saveCheck.formula}}{{/if}}
                            </div>
                        </div>

                    </button>
                </div>
            {{/if}}
        {{/includes}}

    {{/each}}
</div>